<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon"></app-page-title>
<div class="col-sm-12">
    <button class="mb-2 mr-2 btn btn-lg btn-block btn-outline-success" (click)="agregarProducto()">Agregar Nuevo
    </button>
</div>
<div>
    <pre>
    {{
      this.productoForm.value | json
    }}
  </pre>
</div>
<div class="main-card mb-3 card" *ngIf="agregarEditarActive">
    <div class="card-body">
        <h5 class="card-title">Agregar/Editar Producto</h5>
        <form [formGroup]="productoForm" (submit)="agregarEditarProducto()">
            <div class="form-row">
                <div class="col-md-12">
                    <div class="position-relative form-group"><label for="nombre">Nombre</label>
                        <input name="nombre" id="nombre" formControlName="nombre" placeholder="Nombre del producto" type="text" class="form-control">
                    </div>
                </div>
                <div class="col-md-12">
                    <div class="position-relative form-group"><label for="descripcion">Descripcion</label>
                        <textarea name="descripcion" id="descripcion" formControlName="descripcion" placeholder="Descripcion del Producto" type="text" class="form-control">
                        </textarea>
                    </div>
                </div>
            </div>
            <div class="form-row">
                <div class="col-md-4">
                    <div class="position-relative form-group"><label for="marca_id">Marca</label>
                        <select name="marca_id" id="marca_id" type="text" formControlName="marca_id" class="form-control">
                      <option value="">Seleccionar marca</option>
                      <option *ngFor="let marca of this.marcas;" [value]="marca.marca_id">{{marca.nombre}}</option>
                    </select>
                    </div>
                </div>
                <div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="proveedor_id">Proveedor</label>
                        <select name="proveedor_id" id="proveedor_id" class="form-control" formControlName="proveedor_id">
                      <option value="">Selecciona un proveedor</option>
                      <option *ngFor="let p of proveedores" [value]="p.proveedor_id">{{p.nombreComercial}}</option>
                  </select>
                    </div>
                </div>
                <div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="precio">Precio</label>
                        <input name="precio" id="precio" type="text" class="form-control" formControlName="precio">
                        <input name="producto_id" type="text" formControlName="producto_id" hidden readonly>
                        <input name="fechaCreacion" type="text" formControlName="fechaCreacion" hidden readonly>
                        <input name="fechaModificacion" type="text" formControlName="fechaModificacion" hidden readonly>
                    </div>
                </div>
            </div>
            <div class="form-row">
                <div class="col-md-6">
                    <div class="position-relative form-group"><label for="categoriaProducto_id">Categoría</label>
                        <select name="categoriaProducto_id" id="categoriaProducto_id" type="text" formControlName="categoriaProducto_id" class="form-control">
                    <option value="" selected>Seleccionar categoría</option>
                    <option *ngFor="let categoria of this.getCategorias();" [value]="categoria.categoriaProducto_id">{{categoria.nombre}}</option>
                  </select>
                    </div>
                </div>
                <div class="col-md-6">
                    <div class="position-relative form-group">
                        <label for="subCategoriaProducto_id">Subcategoría</label>
                        <select name="subCategoriaProducto_id" id="subCategoriaProducto_id" class="form-control" formControlName="subCategoriaProducto_id">
                    <option value="">Selecciona una subcategoría</option>
                    <option *ngFor="let subcat of this.getSubCategorias()" [value]="subcat.categoriaProducto_id">{{subcat.nombre}}</option>
                </select>
                    </div>
                </div>
            </div>
            <div class="form-row">
                <div class="col-md-6">
                    <div class="position-relative form-group"><label for="marca_id">Género</label>
                        <select name="catGenero_id" id="catGenero_id" type="text" formControlName="catGenero_id" class="form-control">
                  <option value="">Seleccionar género</option>
                  <option *ngFor="let genero of this.generos;" [value]="genero.catGenero_id">{{genero.nombre}}</option>
                </select>
                    </div>
                </div>
                <div class="col-md-6">
                    <div class="position-relative form-group">
                        <label for="proveedor_id">Deporte</label>
                        <select name="catDeporte_id" id="catDeporte_id" class="form-control" formControlName="catDeporte_id">
                  <option value="" selected>Selecciona un deporte</option>
                  <option *ngFor="let d of deportes" [value]="d.catDeporte_id">{{d.nombre}}</option>
              </select>
                    </div>
                </div>
            </div>
            <fieldset>
                <legend>Inventario de Producto</legend>
                <div class="form-row">
                    <div class="col-md-12 text-left" (click)="this.addInventarioForm()">
                        Agregar Configuración <i class="fa fa-plus-square"></i>
                    </div>
                </div>
            </fieldset>
            <div class="form-row">
                <div formArrayName="producto_inventarios">
                    <div *ngFor="let inv of producto_inventarios.controls; let i = index; let my_i = index" class="inventario-outline">
                        <div class="form-row" [formGroupName]="i">
                            <div class="col-md-6">
                                <div class="position-relative form-group">
                                    <label for="catColor_id">Color</label>
                                    <select name="catColor_id" id="catColor_id" class="form-control" formControlName="catColor_id">
                                <option value="" selected>Selecciona un color</option>
                                <option *ngFor="let c of colores" [value]="c.catColor_id">{{c.nombre}}</option>
                              </select>
                                </div>
                            </div>
                            <div class="col-md-6">
                                <div class="position-relative form-group">
                                    <label for="catTipoTalla">Tipo de Talla</label>
                                    <select name="catTipoTalla" id="catTipoTalla" class="form-control" formControlName="catTipoTalla_id" (change)="this.getTallas(my_i)">
                              <option value="" selected>Selecciona un tipo de Talla</option>
                              <option *ngFor="let ctt of catTipoTallas" [value]="ctt.catTipoTalla_id">{{ctt.nombre}}</option>
                            </select>
                                </div>
                            </div>
                            <div class="col-md-6">
                                <div class="position-relative form-group">
                                    <label for="catTipoTalla">Talla</label>
                                    <select name="catTalla" id="catTalla" class="form-control" formControlName="catTalla_id">
                                    <option value="" selected>Selecciona una talla</option>
                                    <option *ngFor="let t of catTallasFiltradas" [value]="t.catTalla_id">{{t.nombre}}</option>
                                  </select>
                                </div>
                            </div>
                            <div class="col-md-6">
                                <div class="position-relative form-group">
                                    <label for="catTipoTalla">Cantidad</label>
                                    <input type="number" name="cantidad" id="cantidad" class="form-control" formControlName="cantidad" />
                                </div>
                            </div>
                            <div class="col-md-8">
                                <div class="position-relative form-group"><label for="files">Imágenes</label>
                                    <input name="files" id="files" type="file" class="form-control-file" multiple (change)="this.uploadFiles(my_i, $event)">
                                    <small class="form-text text-muted">Ingresa imágenes relacionadas al producto.
                                </small>
                                </div>
                            </div>
                            <div class="col-md-4">
                                <div class="position-relative form-group"><label for=""></label>
                                    <input type="button" value="Quitar" (click)="this.removeInventarioForm(i)" class="mt-2 btn btn-danger">
                                </div>
                            </div>
                            <input name="productoInventario_id" type="text" formControlName="productoInventario_id" hidden readonly>
                            <input name="producto_id" type="text" formControlName="producto_id" hidden readonly>
                            <input name="fechaModificacion" type="text" formControlName="fechaModificacion" hidden readonly>
                            <input name="fechaCreacion" type="text" formControlName="fechaCreacion" hidden readonly>
                        </div>
                    </div>
                </div>

            </div>
            <input class="mt-2 btn btn-primary" type="submit" [disabled]="this.productoForm.invalid" [value]="btnmsg" />
        </form>
    </div>
</div>
<div class="main-card mb-3 card">
    <div class="card-body">
        <h5 class="card-title">Productos</h5>
        <div class="table-responsive">
            <table class="align-middle mb-0 table table-borderless table-striped table-hover">
                <thead>
                    <tr>
                        <th class="text-center">#</th>
                        <th class="text-center">Nombre</th>
                        <th class="text-center">Categoría</th>
                        <th class="text-center">Deporte</th>
                        <th class="text-center">Marca</th>
                        <th class="text-center">Proveedor</th>
                        <th class="text-center">Precio</th>
                        <th class="text-center">Acciones</th>
                    </tr>
                </thead>
                <tbody>
                    <tr *ngFor="let prod of this.productos">
                        <td class="text-center text-muted">{{prod.producto_id}}</td>
                        <td class="text-center text-muted">{{prod.nombre}}</td>
                        <td class="text-center">{{prod.categoria_producto.nombre}}</td>
                        <td class="text-center text-muted">{{prod.cat_deporte.nombre}}</td>
                        <td class="text-center text-muted">{{prod.marca.nombre}}</td>
                        <td class="text-center text-muted">{{prod.proveedor.nombreComercial}}</td>
                        <td class="text-center text-muted">{{prod.precio}}</td>
                        <td class="text-center">
                            <button type="button" class="btn btn-outline-light btn-sm" (click)="editarProducto(prod)">Editar</button>
                            <button type="button" class="btn btn-outline-danger btn-sm" (click)="eliminarProducto(prod.producto_id)">Eliminar</button>
                        </td>
                    </tr>
                </tbody>
                <tfoot *ngIf="sinProductos">
                    <tr>
                        <th colspan="8" class="text-center text-danger">No hay productos actualmente</th>
                    </tr>
                </tfoot>
            </table>
        </div>
    </div>
</div>
